
					;LED XeI x [^[

	;RA0	INPUT L
	;RA1	INPUT R
	;RA2	Ach COMM
	;RA3	A/D Vref
	;RA4	Bch COMM

	;OSC1	20MHz CLOCL
	;CSC2	;	;

	;RB0	LED	(MIN LEVEL)
	;RB1	LED
	;RB2	LED
	;RB3	LED
	;RB4	LED
	;RB5	LED
	;RB6	LED
	;RB7	LED	(MAX LEVEL)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	list      p=16f716		; |󎞂ɃXgt@C܂
	#include <p16f716.inc>		; PIC16F716p`t@Cǂݍ݂܂
	errorlevel  -302		; |󎞂302G[oȂ悤ɂ܂

	__CONFIG _CP_OFF &  _WDT_OFF & _HS_OSC	 

	radix	dec			; ȗ̐l\POiɂ܂B

	ORG	000H
	GOTO	INIT 


	DATA_A		EQU	20H
	DATA_B		EQU	21H
;			EQU	22H
	TIMER1		EQU	23H
;			EQU	24H
;			EQU	25H
;			EQU	26H

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;---- [` ----
INIT:

	BSF	STATUS,RP0		;BANK 1

	MOVLW	B'00001011'
	MOVWF	TRISA			;PORTA RA0,1,3̓[h@RA2,4o̓[h

	MOVLW	B'00000000'
	MOVWF	TRISB			;PORTB Sďo̓[h			

	MOVLW   B'10000111'  		;1/256  			             
	MOVWF	OPTION_REG 

	MOVLW	B'00000101'	
	MOVWF	ADCON1			;RA3=Vref, RA2=D, RA1=A, RA0=A (11X=ALL DIGITAL I/0)

	BCF	STATUS,RP0		;BANK 0
	
	CLRF	TIMER1
	CLRF	PORTA
	CLRF	PORTB

	GOTO	MAIN_A1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

					;``lf[^@A/Dϊ	
MAIN_A1
	MOVLW	B'10000001'   		;10=Fosc/32(01=Fosc/8), 000=AN0(001=AN1,010=AN2,011=AN3)
	MOVWF	ADCON0			;0=A/Dϊ(GO/^DONE), 0=_, 1=`^cϊ@\͗L
	CALL	WAIT1			;f[^~ϑ҂
	BSF	ADCON0,GO		;ADCON0,GO(2) ON	A/DϊJn	

MAIN_A1_1
	BTFSC	ADCON0,GO		;ADCON0,GO(2) ON?		
	GOTO	MAIN_A1_1		;YES ϊ
					;NO  ϊ
	MOVF	ADRES,W
	MOVWF	DATA_A			;ADRESDATA_A֑

					;``l\
	BSF	PORTA,2			;
	BSF	PORTA,4			;
	CLRF	PORTB			;PORTBNA
	MOVLW	D'32'
	SUBWF	DATA_A,W		;32-DATA_X=0?
	BTFSC	STATUS,C
	GOTO	MAIN_A1_2		;YES
					;NO			
	CALL	LED_PTN_TABLE_A		
	MOVWF	PORTB			;LED_PTN_TABLẼf[^PORTB֑
	GOTO	MAIN_A1_3

MAIN_A1_2
	MOVLW	B'11111111'
	MOVWF	PORTB

MAIN_A1_3
	BCF	PORTA,2			;PORTA,2 OFF
	CALL	WAIT2			;LED\	

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

					;a`lf[^@A/Dϊ	
MAIN_B1
	MOVLW	B'10001001'   		;10=Fosc/32(01=Fosc/8), 001=AN1(000=AN0,010=AN2,011=AN3)
	MOVWF	ADCON0			;0=A/Dϊ(GO/^DONE), 0=_, 1=A/Dϊ@\L
	CALL	WAIT1			;f[^~ϑ҂
	BSF	ADCON0,GO		;ADCON0,GO(2) ON	A/DϊJn

MAIN_B1_1
	BTFSC	ADCON0,GO		;ADCON0,GO(2) ON?		
	GOTO	MAIN_B1_1		;YES ϊ
					;NO  ϊ
	MOVF	ADRES,W
	MOVWF	DATA_B			;ADRESDATA_B֑

					;a`l\	
	BSF	PORTA,2			;
	BSF	PORTA,4			;
	CLRF	PORTB			;PORTBNA
	MOVLW	D'32'
	SUBWF	DATA_B,W		;32-DATA_B=0?		
	BTFSC	STATUS,C
	GOTO	MAIN_B1_2		;YES
					;NO			
	CALL	LED_PTN_TABLE_B		
	MOVWF	PORTB			;LED_PTN_TABLẼf[^PORTB֑
	GOTO	MAIN_B1_3

MAIN_B1_2
	MOVLW	B'11111111'
	MOVWF	PORTB

MAIN_B1_3
	BCF	PORTA,4			;PORTA,4 OFF
	CALL	WAIT2			;LED\	

	GOTO	MAIN_A1

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

WAIT1					;f[^~ϑ҂ԁ	;50uS
	MOVLW	D'60'
	MOVWF	TIMER1
WAIT1_1
	NOP
	DECFSZ	TIMER1,F
	GOTO	WAIT1_1
	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

WAIT2					;LED\ԁ		;205uS
	MOVLW	D'255'
	MOVWF	TIMER1
WAIT2_1
	NOP
	DECFSZ	TIMER1,F
	GOTO	WAIT2_1
	RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	ORG	100H 

LED_PTN_TABLE_A
	MOVLW	H'01'
	MOVWF	PCLATH	; e[u 0x100`0x1FFԒnɑ

	MOVF	DATA_A,W
	ADDWF	PCL,F

	RETLW	B'00000000'		;0	yRz
	RETLW	B'00000000'		;1
	RETLW	B'00000001'		;2
	RETLW	B'00000001'		;3
	RETLW	B'00000011'		;4
	RETLW	B'00000011'		;5
	RETLW	B'00000111'		;6
	RETLW	B'00000111'		;7

	RETLW	B'00001111'		;0
	RETLW	B'00001111'		;1
	RETLW	B'00011111'		;2
	RETLW	B'00011111'		;3
	RETLW	B'00111111'		;4
	RETLW	B'00111111'		;5
	RETLW	B'01111111'		;6
	RETLW	B'01111111'		;7

	RETLW	B'11111111'		;0
	RETLW	B'11111111'		;1
	RETLW	B'11111111'		;2
	RETLW	B'11111111'		;3
	RETLW	B'11111111'		;4
	RETLW	B'11111111'		;5
	RETLW	B'11111111'		;6
	RETLW	B'11111111'		;7

	RETLW	B'11111111'		;0
	RETLW	B'11111111'		;1
	RETLW	B'11111111'		;2
	RETLW	B'11111111'		;3
	RETLW	B'11111111'		;4
	RETLW	B'11111111'		;5
	RETLW	B'11111111'		;6
	RETLW	B'11111111'		;7


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

LED_PTN_TABLE_B
	MOVLW	H'01'
	MOVWF	PCLATH	; e[u 0x100`0x1FFԒnɑ

	MOVF	DATA_B,W
	ADDWF	PCL,F

	RETLW	B'00000000'		;0	yRz
	RETLW	B'00000000'		;1
	RETLW	B'00000001'		;2
	RETLW	B'00000001'		;3
	RETLW	B'00000011'		;4
	RETLW	B'00000011'		;5
	RETLW	B'00000111'		;6
	RETLW	B'00000111'		;7

	RETLW	B'00001111'		;0
	RETLW	B'00001111'		;1
	RETLW	B'00011111'		;2
	RETLW	B'00011111'		;3
	RETLW	B'00111111'		;4
	RETLW	B'00111111'		;5
	RETLW	B'01111111'		;6
	RETLW	B'01111111'		;7

	RETLW	B'11111111'		;0
	RETLW	B'11111111'		;1
	RETLW	B'11111111'		;2
	RETLW	B'11111111'		;3
	RETLW	B'11111111'		;4
	RETLW	B'11111111'		;5
	RETLW	B'11111111'		;6
	RETLW	B'11111111'		;7

	RETLW	B'11111111'		;0
	RETLW	B'11111111'		;1
	RETLW	B'11111111'		;2
	RETLW	B'11111111'		;3
	RETLW	B'11111111'		;4
	RETLW	B'11111111'		;5
	RETLW	B'11111111'		;6
	RETLW	B'11111111'		;7

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	END

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	RETLW	B'00000000'		;0	yPz
	RETLW	B'00000001'		;1
	RETLW	B'00000011'		;2
	RETLW	B'00000111'		;3
	RETLW	B'00001111'		;4
	RETLW	B'00011111'		;5
	RETLW	B'00111111'		;6
	RETLW	B'01111111'		;7

	RETLW	B'11111111'		;0
	RETLW	B'11111111'		;1
	RETLW	B'11111111'		;2
	RETLW	B'11111111'		;3
	RETLW	B'11111111'		;4
	RETLW	B'11111111'		;5
	RETLW	B'11111111'		;6
	RETLW	B'11111111'		;7

	RETLW	B'11111111'		;0
	RETLW	B'11111111'		;1
	RETLW	B'11111111'		;2
	RETLW	B'11111111'		;3
	RETLW	B'11111111'		;4
	RETLW	B'11111111'		;5
	RETLW	B'11111111'		;6
	RETLW	B'11111111'		;7

	RETLW	B'11111111'		;0
	RETLW	B'11111111'		;1
	RETLW	B'11111111'		;2
	RETLW	B'11111111'		;3
	RETLW	B'11111111'		;4
	RETLW	B'11111111'		;5
	RETLW	B'11111111'		;6
	RETLW	B'11111111'		;7

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	RETLW	B'00000000'		;0	yQz
	RETLW	B'00000001'		;1
	RETLW	B'00000001'		;2
	RETLW	B'00000011'		;3
	RETLW	B'00000111'		;4
	RETLW	B'00000111'		;5
	RETLW	B'00001111'		;6
	RETLW	B'00011111'		;7

	RETLW	B'00011111'		;0
	RETLW	B'00111111'		;1
	RETLW	B'01111111'		;2
	RETLW	B'01111111'		;3
	RETLW	B'11111111'		;4
	RETLW	B'11111111'		;5
	RETLW	B'11111111'		;6
	RETLW	B'11111111'		;7

	RETLW	B'11111111'		;0
	RETLW	B'11111111'		;1
	RETLW	B'11111111'		;2
	RETLW	B'11111111'		;3
	RETLW	B'11111111'		;4
	RETLW	B'11111111'		;5
	RETLW	B'11111111'		;6
	RETLW	B'11111111'		;7

	RETLW	B'11111111'		;0
	RETLW	B'11111111'		;1
	RETLW	B'11111111'		;2
	RETLW	B'11111111'		;3
	RETLW	B'11111111'		;4
	RETLW	B'11111111'		;5
	RETLW	B'11111111'		;6
	RETLW	B'11111111'		;7

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	RETLW	B'00000000'		;0	yRz
	RETLW	B'00000000'		;1
	RETLW	B'00000001'		;2
	RETLW	B'00000001'		;3
	RETLW	B'00000011'		;4
	RETLW	B'00000011'		;5
	RETLW	B'00000111'		;6
	RETLW	B'00000111'		;7

	RETLW	B'00001111'		;0
	RETLW	B'00001111'		;1
	RETLW	B'00011111'		;2
	RETLW	B'00011111'		;3
	RETLW	B'00111111'		;4
	RETLW	B'00111111'		;5
	RETLW	B'01111111'		;6
	RETLW	B'01111111'		;7

	RETLW	B'11111111'		;0
	RETLW	B'11111111'		;1
	RETLW	B'11111111'		;2
	RETLW	B'11111111'		;3
	RETLW	B'11111111'		;4
	RETLW	B'11111111'		;5
	RETLW	B'11111111'		;6
	RETLW	B'11111111'		;7

	RETLW	B'11111111'		;0
	RETLW	B'11111111'		;1
	RETLW	B'11111111'		;2
	RETLW	B'11111111'		;3
	RETLW	B'11111111'		;4
	RETLW	B'11111111'		;5
	RETLW	B'11111111'		;6
	RETLW	B'11111111'		;7

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	RETLW	B'00000000'		;0	ySz
	RETLW	B'00000000'		;1
	RETLW	B'00000001'		;2
	RETLW	B'00000001'		;3
	RETLW	B'00000001'		;4
	RETLW	B'00000011'		;5
	RETLW	B'00000011'		;6
	RETLW	B'00000111'		;7

	RETLW	B'00000111'		;0
	RETLW	B'00000111'		;1
	RETLW	B'00001111'		;2
	RETLW	B'00001111'		;3
	RETLW	B'00011111'		;4
	RETLW	B'00011111'		;5
	RETLW	B'00011111'		;6
	RETLW	B'00111111'		;7

	RETLW	B'00111111'		;0
	RETLW	B'01111111'		;1
	RETLW	B'01111111'		;2
	RETLW	B'01111111'		;3
	RETLW	B'11111111'		;4
	RETLW	B'11111111'		;5
	RETLW	B'11111111'		;6
	RETLW	B'11111111'		;7

	RETLW	B'11111111'		;0
	RETLW	B'11111111'		;1
	RETLW	B'11111111'		;2
	RETLW	B'11111111'		;3
	RETLW	B'11111111'		;4
	RETLW	B'11111111'		;5
	RETLW	B'11111111'		;6
	RETLW	B'11111111'		;7

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	RETLW	B'00000000'		;0	yTz
	RETLW	B'00000000'		;1
	RETLW	B'00000000'		;2
	RETLW	B'00000001'		;3
	RETLW	B'00000001'		;4
	RETLW	B'00000001'		;5
	RETLW	B'00000001'		;6
	RETLW	B'00000011'		;7

	RETLW	B'00000011'		;0
	RETLW	B'00000011'		;1
	RETLW	B'00000111'		;2
	RETLW	B'00000111'		;3
	RETLW	B'00000111'		;4
	RETLW	B'00000111'		;5
	RETLW	B'00001111'		;6
	RETLW	B'00001111'		;7

	RETLW	B'00001111'		;0
	RETLW	B'00011111'		;1
	RETLW	B'00011111'		;2
	RETLW	B'00011111'		;3
	RETLW	B'00011111'		;4
	RETLW	B'00111111'		;5
	RETLW	B'00111111'		;6
	RETLW	B'00111111'		;7

	RETLW	B'01111111'		;0
	RETLW	B'01111111'		;1
	RETLW	B'01111111'		;2
	RETLW	B'01111111'		;3
	RETLW	B'11111111'		;4
	RETLW	B'11111111'		;5
	RETLW	B'11111111'		;6
	RETLW	B'11111111'		;7

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	RETLW	B'00000000'		;0	yUz
	RETLW	B'00000000'		;1
	RETLW	B'00000000'		;2
	RETLW	B'00000001'		;3
	RETLW	B'00000001'		;4
	RETLW	B'00000001'		;5
	RETLW	B'00000011'		;6
	RETLW	B'00000011'		;7

	RETLW	B'00000011'		;0
	RETLW	B'00000111'		;1
	RETLW	B'00000111'		;2
	RETLW	B'00000111'		;3
	RETLW	B'00001111'		;4
	RETLW	B'00001111'		;5
	RETLW	B'00001111'		;6
	RETLW	B'00011111'		;7

	RETLW	B'00011111'		;0
	RETLW	B'00011111'		;1
	RETLW	B'00111111'		;2
	RETLW	B'00111111'		;3
	RETLW	B'00111111'		;4
	RETLW	B'01111111'		;5
	RETLW	B'01111111'		;6
	RETLW	B'01111111'		;7

	RETLW	B'11111111'		;0
	RETLW	B'11111111'		;1
	RETLW	B'11111111'		;2
	RETLW	B'11111111'		;3
	RETLW	B'11111111'		;4
	RETLW	B'11111111'		;5
	RETLW	B'11111111'		;6
	RETLW	B'11111111'		;7

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

	RETLW	B'00000000'		;0	yVz
	RETLW	B'00000000'		;1
	RETLW	B'00000000'		;2
	RETLW	B'00000000'		;3
	RETLW	B'00000001'		;4
	RETLW	B'00000001'		;5
	RETLW	B'00000001'		;6
	RETLW	B'00000001'		;7

	RETLW	B'00000011'		;0
	RETLW	B'00000011'		;1
	RETLW	B'00000011'		;2
	RETLW	B'00000011'		;3
	RETLW	B'00000111'		;4
	RETLW	B'00000111'		;5
	RETLW	B'00000111'		;6
	RETLW	B'00000111'		;7

	RETLW	B'00001111'		;0
	RETLW	B'00001111'		;1
	RETLW	B'00001111'		;2
	RETLW	B'00001111'		;3
	RETLW	B'00011111'		;4
	RETLW	B'00011111'		;5
	RETLW	B'00011111'		;6
	RETLW	B'00011111'		;7

	RETLW	B'00111111'		;0
	RETLW	B'00111111'		;1
	RETLW	B'00111111'		;2
	RETLW	B'00111111'		;3
	RETLW	B'01111111'		;4
	RETLW	B'01111111'		;5
	RETLW	B'01111111'		;6
	RETLW	B'01111111'		;7

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
















